﻿using System;
using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;

namespace WE_SecondTextEditor
{
    internal class CustomCreationFilter : IUIElementCreationFilter
    {
        private TextUIElement additionalTextElement;

        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is EditorButtonUIElement)
            {
                var editorElement = parent.Parent as EditorWithTextUIElement;

                if (additionalTextElement == null)
                {
                    additionalTextElement = new TextUIElement(editorElement, "AB");
                
                }

                additionalTextElement.Rect = parent.Rect;
                editorElement.ChildElements.Add(additionalTextElement);
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }

    internal class CustomDrawFilter : IUIElementDrawFilter
    {
        public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
        {
            return true;
        }

        public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
        {
            if (drawParams.Element is EditorButtonUIElement)
                return DrawPhase.BeforeDrawElement;
            else
                return DrawPhase.None;
        }
    }
}